/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.VigenciaTarifaDAO;
import com.rjconsultores.ventaboletos.entidad.VigenciaTarifa;
import com.rjconsultores.ventaboletos.service.VigenciaTarifaService;
import com.rjconsultores.ventaboletos.utilerias.DateUtil;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

/**
 *
 * @author rodrigo
 */
@Service("vigenciaTarifaService")
public class VigenciaTarifaServiceImpl implements VigenciaTarifaService {

	@Autowired
	private VigenciaTarifaDAO vigenciaTarifaDAO;

	public List<VigenciaTarifa> obtenerTodos() {
		return vigenciaTarifaDAO.obtenerTodos();
	}

	public VigenciaTarifa obtenerID(Integer id) {
		return vigenciaTarifaDAO.obtenerID(id);
	}

	@Transactional
	public VigenciaTarifa suscribir(VigenciaTarifa entidad) {
		entidad = forcePeriodLimits(entidad);

		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return vigenciaTarifaDAO.suscribir(entidad);
	}

	@Transactional
	public VigenciaTarifa actualizacion(VigenciaTarifa entidad) {
		entidad = forcePeriodLimits(entidad);

		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return vigenciaTarifaDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(VigenciaTarifa entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		vigenciaTarifaDAO.actualizacion(entidad);
	}

	public List<VigenciaTarifa> pesquisar(Date inicio, Date fim) {
		return vigenciaTarifaDAO.pesquisar(inicio, fim);
	}

	public List<VigenciaTarifa> buscarVigenciasIntervalo(VigenciaTarifa vigenciaTarifa) {
		return vigenciaTarifaDAO.buscarVigenciasIntervalo(vigenciaTarifa);
	}

	private VigenciaTarifa forcePeriodLimits(VigenciaTarifa entidad) {
		entidad.setFeciniciovigencia(DateUtil.inicioFecha(entidad.getFeciniciovigencia()));
		entidad.setFecfinvigencia(DateUtil.fimFecha(entidad.getFecfinvigencia()));

		return entidad;
	}
}
